package binary_tree;

import java.util.Iterator;

public interface BinaryTree<E> {
	
	public boolean isEmpty();
	
	public int size();
	
	public void clear();
	
	public E getRoot();
	
	public boolean contains(E targetElement);
	
	public Iterator<E> iteratorInOrder();
	
	public Iterator<E> iteratorPreOrder();
	
	public Iterator<E> iteratorPostOrder();
	
	public Iterator<E> iteratorLevelOrder();
	
	public String toString();
	
}
